#include <errno.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/telnet.h>
#include <netdb.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <termio.h>
#include <utime.h>
#include <unistd.h>

#include "config.h"

extern char **gargv;

int waitfordata(int,int);
int waitforsend(int,int);
long fnGetBandWidth();

void alrmread(void) {} 

unsigned long dir_INET(char *hostName)
   {
   struct hostent* hostStruct;
   struct in_addr* hostNode;
   printf("Localizando IP de %s...",hostName);
   fflush(stdout);
   hostStruct=gethostbyname(hostName);
   if (hostStruct==NULL)
        {
        printf("\nNo existe el IP\n");
        exit(-1);
        }
   hostNode=(struct in_addr*) hostStruct->h_addr;
   printf("%s\n",inet_ntoa(*hostNode));
   return (hostNode->s_addr);
}


int putline(int sock, char *linea)
{
  char *tmp=(char *)malloc(strlen(linea)+10);
  if(tmp==NULL) {
    printf("No hay memoria\n");
    close(sock);
    return 1;
  }
  bzero(tmp,strlen(linea)+10);
  strcpy(tmp,linea);
  strcat(tmp,"\r\n");
  if(waitforsend(sock,TOUT)) {
    printf("Error al mandar datos, reiniciando conexion FTP\n");
    close(sock);
    return 1;
  }
  if((send(sock,tmp,strlen(tmp),0))<=0) {
    printf("\nputlineerror\n");
    close(sock);
    return 1;
  }
  free(tmp);
#ifdef DEBUG  
  printf(">> %s\n",linea);
#endif  
  return 0;
}
char *getline(int sock, char *linea)
{
  int i,r;
  time_t tout=time(NULL);
  if(linea!=NULL) linea=(char *)realloc(linea,1);
  for(i=0;;) {
#ifdef DEBUG
    printf("TOUT %d\x0d",time(NULL)-tout);
    fflush(stdout);
#endif    
    if((time(NULL)-tout)>20) {
    	if(linea!=NULL) free(linea), linea=NULL;
    	break;
    }
    if(checkr(sock)) {
      linea=(char *)realloc(linea,i+256);
      linea[i]=linea[i+1]=0;
      if((r=recv(sock,(char *)&linea[i],1,0))<=0) {
      if(errno==EBADF||errno==ENOTCONN||errno==ENOTSOCK||errno==EWOULDBLOCK||
         errno==EFAULT) {
          perror("\ngetline-recv");
          printf("errno: %d  %d %d\n",errno,r,checkr(sock));
          close(sock);
          return NULL;
        }
      } 
      if(linea[i]=='\n') break;
    } else r=0;
    if(r>0) i+=r, tout=time(NULL); 
  }
  if(i>0) linea[i]=0;
#ifdef DEBUG
  printf("\n> %s\n",linea);
#endif    
  return(linea);
}
  
char *getlinels(int sock, char *linea)
{
  int i, r;
  time_t tout=time(NULL);
  if(linea!=NULL) linea=(char *)realloc(linea,1);
  for(i=0;;) {
    if((time(NULL)-tout)>20) {
    	if(linea!=NULL) free(linea), linea=NULL;
    	break;
    }
    if(checkr(sock)) {
      linea=(char *)realloc((char *)linea,i+10);
      linea[i]=linea[i+1]=0;
      errno=0;
      if((r=recv(sock,(char *)&linea[i],1,0))<=0) {
      if(linea[i]==0&&errno==0) break;
//      if(linea[i]<32||(unsigned char)linea[i]>240) printf("%02x %d ",linea[i],errno);
//      if(errno==17) perror("errno"), sleep(1);
      if(errno==EBADF||errno==ENOTCONN||errno==ENOTSOCK||errno==EWOULDBLOCK||
         errno==EFAULT) {
          perror("\ngetlinels-recv");
          printf("errno: %d  %d %d\n",errno,r,checkr(sock));
          close(sock);
          return NULL;
        }
      }
      linea[i+1]=0;
      if(linea[i]=='\n') break;
    } else r=0;
    if(r>0) i+=r, tout=time(NULL);
  }
  if(i>0) linea[i]=0;
#ifdef DEBUG
  printf("> %s\n",linea);
#endif    
  return(linea);
}


int checkr(sock)
int sock;
{
  int r;
  fd_set ready, otros;
#if TIMEVALORSPEC == 2
  struct timespec to;
#else
  struct timeval to;
#endif  
  char buffer[10];
  FD_ZERO(&ready);
  FD_SET(sock, &ready);
  FD_ZERO(&otros);
  FD_SET(sock, &otros);
  to.tv_sec = 1;
#if TIMEVALORSPEC == 2
  to.tv_nsec = 0;
#else    
  to.tv_usec = 0;
#endif  
  if (select(sock+1, &ready, 0, &otros, &to) < 0) { usleep(1); return -1; }
  if(FD_ISSET(sock,&otros)) printf("SELECT: otros\n");
  if(FD_ISSET(sock,&ready)) {
    signal(SIGALRM,(void *)alrmread);
    alarm(TOUT);
    if((r=recv(sock,buffer,1,MSG_PEEK))<=0) {
      if(errno) {
        switch(errno) {
//          case 2: break;
          case 13: break; // Permision denied
          case 17: break; // File exists
          case EBADF:
          case ENOTCONN:
          case ENOTSOCK:
          case EWOULDBLOCK:
          case EFAULT:
            perror("\ncheckr-recv");
            printf("errno: %d  %d\n",errno,r);
            sleep(1);
            signal(SIGALRM,SIG_IGN);
            return -2;
//          default:
//            perror("\ncheckr-recv");
//            printf("errno: %d  %d\n",errno,r);
//            sleep(1);
        }
        signal(SIGALRM,SIG_IGN);
        return -2;
      }
    }
    signal(SIGALRM,SIG_IGN);
    return(1);
  }
  usleep(1);
  return(0);
}


int checkw(sock)
int sock;
{
  fd_set ready, otros;
#if TIMEVALORSPEC == 2
  struct timespec to;
#else
  struct timeval to;
#endif  
  char buffer[10];
  FD_ZERO(&ready);
  FD_SET(sock, &ready);
  FD_ZERO(&otros);
  FD_SET(sock, &otros);
  to.tv_sec = 1;
#if TIMEVALORSPEC == 2
  to.tv_nsec = 10000;
#else    
  to.tv_usec = 10000;
#endif  
  if (select(sock+1, 0, &ready, &otros, &to) < 0) return -1;
  if(FD_ISSET(sock,&otros)) printf("SELECTW: otros\n");
  if(FD_ISSET(sock,&ready)) {
    return(1);
  }
  return(0);
}


int waitfordata(int s, int t)
{
  time_t T=time(NULL);
/*  printf("wfd\x0d");
  fflush(stdout);
  sleep(1);*/
  while(!checkr(s)&&(time(NULL)-T)<=t) {
#ifdef DEBUG
    printf("WFD %d\x0d",(time(NULL)-T));
#endif
    sleep(1);
  }
/*  printf("wfe\x0d");
  fflush(stdout);
  sleep(1);*/
  if(checkr(s)) return 0; else return 1;
}

int waitforsend(int s, int t)
{
  time_t T=time(NULL);
  while(!checkw(s)&&(time(NULL)-T)<=t) sleep(1);
  if(checkw(s)) return 0; else return 1;
}
int cmdABORT(int sock)
{
    char tt[16], buf[16];
    sprintf(buf,"%c%c%c",IAC,IP,IAC);
    send(sock,buf,3,MSG_OOB);
    
    sprintf(tt,"%cABOR",DM);
    putline(sock,tt);
    return 0;
}

/* Esta funcion trata de determinar el tipo de medios que se estan utilizando
   para la comunicacion, le falta mas desarrollo
*/   
long fnGetBandWidth(void)
{
  FILE *fp;
  char r[512];
  char buf[512], interf[512];
  sprintf(r,"route -n | grep -i \"0.0.0.0.*0.0.0.0\"");
  if((fp=popen(r,"rt"))==NULL) return 4096;
  if(!fgets(buf,sizeof(buf),fp)) {
    fclose(fp);
    return 4096;
  }
  fclose(fp);
  sscanf(buf,"%s%s%s%s%s%s%s%s",buf,buf,buf,buf,buf,buf,buf,interf);
  if(!strncmp(interf,"eth",3)) return (1024*1024);
  if(!strncmp(interf,"ppp",3)) return (1024*8);
  if(!strncmp(interf,"sl",2)) return (1024*8);
  return 4096;
}  
  